IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PERSON]') AND type in (N'U'))
DROP TABLE [dbo].[PERSON]

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ACCOUNT]') AND type in (N'U'))
DROP TABLE [dbo].[ACCOUNT]

create table PERSON (id integer, name varchar(250));
create table ACCOUNT (id integer, person_id integer, amount numeric(17,3));

insert into PERSON values(1, 'Smith');
insert into PERSON values(2, 'Brown');

insert into ACCOUNT values(1, 1, 50.0);
insert into ACCOUNT values(2, 2, 100.0);

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[TransferAmount]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[TransferAmount]
GO

CREATE PROCEDURE TransferAmount( 
	@nFromAccount int, @nToAccount int, @fAmount numeric(17,3))
AS
DECLARE @errorAmount numeric(17,3)
BEGIN
    BEGIN TRANSACTION;
	update ACCOUNT set AMOUNT=AMOUNT-@fAmount where ID=@nFromAccount;
    update ACCOUNT set AMOUNT=AMOUNT+@fAmount where ID=@nToAccount;
    set @errorAmount = @fAmount+(select AMOUNT from ACCOUNT where ID=@nFromAccount);
    if (@errorAmount<0.0)    
    begin
	declare @amountString varchar(100);
        set @amountString = CAST(@errorAmount as varchar);
        ROLLBACK;
        RAISERROR(N'    %i: %s', 11, 1, @nFromAccount, @amountString);        
    end;
    COMMIT;
END
GO
