package org.mai806.jdbcsample;

import java.sql.*;

public class QuerySample {
    
    public static void main(String[] args) throws Exception {
        
        /* ========   MS SQL Server ===== */
        //  
        Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        //    
        Connection connection = DriverManager.getConnection(
                "jdbc:sqlserver://localhost:1433;databaseName=o01;", // localhost -  , o01 -   
                "sa", "123"); // , 
        
        /* ========   Oracle ============
        //  
        Class.forName("oracle.jdbc.OracleDriver");
        //    
        Connection connection = DriverManager.getConnection(
                        "jdbc:oracle:thin:@localhost:1521:orcl", // localhost -  , orcl - SID  
                        "o01", "o01"); // , 
         */
        
        //  Statement
        PreparedStatement stmt = connection.prepareStatement("select ID, NAME from PERSON where NAME like ?");
        stmt.setString(1, "%S%");
        //  
        ResultSet rs = stmt.executeQuery();
        //    
        while(rs.next()) {
            //        
            System.out.println("ID: " +
                    rs.getLong(1) + "; NAME="+
                    rs.getString("NAME"));
        }
        
        //    
        rs.close();
        stmt.close();
        connection.close();
    }
}
