package org.mai806.jdbcsample;

import java.sql.*;
import java.util.ResourceBundle;

public class TransactionalSample {
    
    private static Connection connection = null;
    public static void main(String[] args) throws Exception {
        
        //        properties
        ResourceBundle properties = ResourceBundle.getBundle("database");
        Class.forName(properties.getString("driver"));
        connection = DriverManager.getConnection(
                properties.getString("url"),
                properties.getString("user"),
                properties.getString("password"));
        
        //   
        connection.setAutoCommit(false);
        
        try {
            transferAmount(2, 1, 10.0);
        } finally {
            connection.close();
        }
    }
    
    /**
     *        
     * @param from  
     * @param to  
     * @param amount 
     */
    public static void transferAmount(long from, long to,
            double amount) throws Exception {
        PreparedStatement stmt = null;
        Statement query = null;
        try {
            stmt = connection.prepareStatement("update ACCOUNT set AMOUNT=AMOUNT+? where ID=?");
            //     
            stmt.setDouble(1, -amount);
            stmt.setLong(2, from);
            stmt.execute();
            
            //     
            stmt.setDouble(1, amount);
            stmt.setLong(2, to);
            stmt.execute();
            
            // -:   
            query = connection.createStatement();
            ResultSet rs = query.executeQuery(
                    "select AMOUNT from ACCOUNT where ID="+from+" and AMOUNT<0");
            if (rs.next()) {
                throw new Exception("  "+from+"   ["+(amount+rs.getDouble(1))+"]    ["+amount+"]");
            }
            connection.commit();
            System.out.println("   ");
        } catch(Exception e) {
            e.printStackTrace();
            connection.rollback();
        } finally {
            if (stmt!=null)
                stmt.close();
            if (query!=null)
                query.close();
        }
    }
    
}
